/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/


void Form1::Open()
{
filename=QFileDialog.getOpenFileName(self.director, "*.txt *.lrc", self, "FileDialog")
filename_for_open=str(filename.local8Bit())
if(str(filename.utf8())<>''):
        file=open(filename_for_open,'r')
        file_context=file.read()
        file.close()
        self.textEdit1.clear()
        try:
        	file_context=unicode(file_context,self.list_encoder[self.comboBox1.currentItem()]).encode('utf8')
        except UnicodeDecodeError:
        	QMessageBox.critical(self,'错误'.decode('utf8'),'文件编码错误'.decode('utf8'))
        else:
        	self.textEdit1.setText(file_context.decode('utf8'))
else:
	pass
}


void Form1::ExportLrcFile()
{
try:
	num=int(str(self.lineEdit5.text().utf8()))
except ValueError:
	head='[ti:%s]\n[ar:%s]\n[al:%s]\n[by:%s]\n' %(self.lineEdit1.text().utf8(),self.lineEdit2.text().utf8(),self.lineEdit3.text().utf8(),self.lineEdit4.text().utf8())
else:
	if(-1000<=num<=1000 and num<>0):
		head='[ti:%s]\n[ar:%s]\n[al:%s]\n[by:%s]\n[offset:%s]\n' %(self.lineEdit1.text().utf8(),self.lineEdit2.text().utf8(),self.lineEdit3.text().utf8(),self.lineEdit4.text().utf8(),self.lineEdit5.text().utf8())
	else:
		head='[ti:%s]\n[ar:%s]\n[al:%s]\n[by:%s]\n' %(self.lineEdit1.text().utf8(),self.lineEdit2.text().utf8(),self.lineEdit3.text().utf8(),self.lineEdit4.text().utf8())
context=head+str(self.textEdit1.text().utf8())
try:
        context=unicode(context,'utf_8').encode(self.list_encoder[self.comboBox1.currentItem()])
except UnicodeEncodeError:
	QMessageBox.critical(self,'错误'.decode('utf8'),'文件编码错误'.decode('utf_8'))
else:
	suggest_name='%s - %s.lrc' %(self.lineEdit2.text().utf8(),self.lineEdit1.text().utf8())
	filename=QFileDialog.getSaveFileName('%s/%s' %(self.director,suggest_name.decode('utf8')),'*.txt *.lrc', self,'FileDialog')
	if(str(filename.utf8())<>''):
		file=open(str(filename.local8Bit()),'w')
		file.write(context)
		file.close()
	else:
		pass
}


void Form1::InsertTag()
{
currentTime=int(dcop('dcop amarok player trackCurrentTimeMs'))
munites,ms=divmod(currentTime,60000)
if(len(str(ms))<>5):
        seconds='0'+str(ms)[0]
else:
        seconds=str(ms)[0:2]
mseconds=str(ms)[-3:-1]
munites=str(munites)
if(len(munites)<>2):
        munites='0'+munites
currentTag='[%s:%s.%s]' %(munites,seconds,mseconds)
self.textEdit1.insert(currentTag)
self.textEdit1.moveCursor(QTextEdit.MoveLineStart,0)
self.textEdit1.moveCursor(QTextEdit.MoveDown,0)
}


void Form1::DelLatestTag()
{
self.textEdit1.undo()
}


void Form1::DelAllTags()
{
lrc_before=str(self.textEdit1.text().utf8())
self.textEdit1.clear()
lrc_after=re.sub('\[\d\d:\d\d.*?\]','',lrc_before)
self.textEdit1.setText(lrc_after.decode('utf8'))
}


void Form1::DelHead()
{
lrc_before=str(self.textEdit1.text().utf8())
self.textEdit1.clear()
lrc_after=re.sub('\[[a-z,A-Z]{1,}:.*?\]\n','',lrc_before)
self.textEdit1.setText(lrc_after.decode('utf8'))
}


void Form1::CutPoint()
{
lrc_before=str(self.textEdit1.text().utf8())
self.textEdit1.clear()
lrc_after=re.sub('\.\d\d\]',']',lrc_before)
self.textEdit1.setText(lrc_after.decode('utf8'))
}


void Form1::DelSpace()
{
lrc_before=str(self.textEdit1.text().utf8())
self.textEdit1.clear()
lrc_before=re.sub('^\s{1,}|\s{1,}$','',lrc_before)
lrc_after=re.sub('\s{0,}\n\s{0,}','\n',lrc_before)
self.textEdit1.setText(lrc_after.decode('utf8'))
}



void Form1::Pause()
{
os.system('dcop amarok player pause')
self.Status()
}


void Form1::Play()
{
os.system('dcop amarok player play')
self.Status()
}


void Form1::Stop()
{
os.system('dcop amarok player stop')
self.Status()
}


void Form1::Prev()
{
os.system('dcop amarok player prev')
}


void Form1::Next()
{
os.system('dcop amarok player next')
}


void Form1::Contents()
{
QMessageBox.information(self,'提示'.decode('utf8'),'阅读README，获得更多帮助'.decode('utf8'))
}


void Form1::About()
{
about_text='一个依赖pyqt3的lrc歌词编辑器\n需要和Amarok同时运行\n点击“内容”获得更多的帮助\n\n作者：三翻领\nxml分析器：qp\nlogo设计：hnstxx\n\nBug报告：xujia19@gmail.com\n\n中文主页：http://www.sanfanling.cn/article.asp?id=144'
about_title='关于Lrceditor-Amarok'
QMessageBox.about(self,about_title.decode('utf8'),about_text.decode('utf8'))
}


void Form1::Progress()
{
if(dcop('dcop amarok player isPlaying')=='true'):
	self.mytimer.start(1000,True)
        value=int(dcop('dcop amarok player trackCurrentTime'))
        self.slider1.setMaxValue(int(dcop('dcop amarok player trackTotalTime')))
        totaltime=dcop('dcop amarok player totalTime')
        currenttime=dcop('dcop amarok player currentTime')
        self.textLabel1.setText('%s/%s' %(currenttime,totaltime))
        self.slider1.setValue(value)
elif(dcop('dcop amarok player isPlaying')=='false' and dcop('dcop amarok player currentTime')==''):
	self.Status()
elif(os.system('dcop amarok >/dev/null')==256):
	self.Status()
}


void Form1::SeekBackward()
{
os.system('dcop amarok player seekRelative -5')
}


void Form1::SeekForward()
{
os.system('dcop amarok player seekRelative 5')
}


void Form1::Status()
{
if(os.system('dcop amarok >/dev/null')==256):
	self.pushButton1.setEnabled(0)
	self.pushButton2.setEnabled(0)
	self.pushButton3.setEnabled(0)
	self.pushButton4.setEnabled(0)
	self.pushButton5.setEnabled(0)
	self.pushButton8.setEnabled(0)
	self.pushButton9.setEnabled(0)
	self.amarokPlayAction.setEnabled(0)
	self.amarokPauseAction.setEnabled(0)
	self.amarokStopAction.setEnabled(0)
	self.amarokPrevAction.setEnabled(0)
	self.amarokNextAction.setEnabled(0)
	self.amarokSeekBackwardAction.setEnabled(0)
	self.amarokSeekForwardAction.setEnabled(0)
	self.pushButton6.setEnabled(0)
	self.pushButton7.setEnabled(0)
	self.editInsertTagAction.setEnabled(0)
	self.editDelLatestTagAction.setEnabled(0)
	self.textLabel1.setText('--:--/--:--')
	self.slider1.setValue(0)
	self.mytimer.stop()
else:
	if(dcop('dcop amarok player isPlaying')=='true'):
		self.pushButton1.setEnabled(0)
		self.pushButton2.setEnabled(1)
		self.pushButton3.setEnabled(1)
		self.pushButton4.setEnabled(1)
		self.pushButton5.setEnabled(1)
		self.pushButton8.setEnabled(1)
		self.pushButton9.setEnabled(1)
		self.amarokPlayAction.setEnabled(0)
		self.amarokPauseAction.setEnabled(1)
		self.amarokStopAction.setEnabled(1)
		self.amarokPrevAction.setEnabled(1)
		self.amarokNextAction.setEnabled(1)
		self.amarokSeekBackwardAction.setEnabled(1)
		self.amarokSeekForwardAction.setEnabled(1)
		self.pushButton6.setEnabled(1)
		self.pushButton7.setEnabled(1)
		self.editInsertTagAction.setEnabled(1)
		self.editDelLatestTagAction.setEnabled(1)
		self.Progress()
	elif(dcop('dcop amarok player isPlaying')=='false' and dcop('dcop amarok player currentTime')<>''):   #is paused
		self.pushButton1.setEnabled(1)
		self.pushButton2.setEnabled(0)
		self.pushButton3.setEnabled(1)
		self.pushButton4.setEnabled(1)
		self.pushButton5.setEnabled(1)
		self.pushButton8.setEnabled(1)
		self.pushButton9.setEnabled(1)
		self.amarokPlayAction.setEnabled(1)
		self.amarokPauseAction.setEnabled(0)
		self.amarokStopAction.setEnabled(1)
		self.amarokPrevAction.setEnabled(1)
		self.amarokNextAction.setEnabled(1)
		self.amarokSeekBackwardAction.setEnabled(1)
		self.amarokSeekForwardAction.setEnabled(1)
		self.pushButton6.setEnabled(1)
		self.pushButton7.setEnabled(1)
		self.editInsertTagAction.setEnabled(1)
		self.editDelLatestTagAction.setEnabled(1)
		self.Progress()
	elif(dcop('dcop amarok player isPlaying')=='false' and dcop('dcop amarok player currentTime')==''):   #is stoped
		self.pushButton1.setEnabled(1)
		self.pushButton2.setEnabled(0)
		self.pushButton3.setEnabled(0)
		self.pushButton4.setEnabled(1)
		self.pushButton5.setEnabled(1)
		self.pushButton8.setEnabled(0)
		self.pushButton9.setEnabled(0)
		self.amarokPlayAction.setEnabled(1)
		self.amarokPauseAction.setEnabled(0)
		self.amarokStopAction.setEnabled(0)
		self.amarokPrevAction.setEnabled(1)
		self.amarokNextAction.setEnabled(1)
		self.amarokSeekBackwardAction.setEnabled(0)
		self.amarokSeekForwardAction.setEnabled(0)
		self.pushButton6.setEnabled(0)
		self.pushButton7.setEnabled(0)
		self.editInsertTagAction.setEnabled(0)
		self.editDelLatestTagAction.setEnabled(0)
		self.textLabel1.setText('--:--/--:--')
		self.slider1.setValue(0)
		self.mytimer.stop()
}
